<template>
  <div class="p-1">

    <h2 class="mh-5 mt-1 mb-0"><i>SETUP</i></h2>
    <Error v-if="error" :error.sync="error" round class="mv-5"/>

    <p>Let us know a little about yourself before you continue.</p>

    <div class="input-group rwrap mv-2">
      <!-- <input type="text" placeholder="Bio"> -->
      <textarea rows="2"></textarea>
      <span>Bio</span>
    </div>

    <div class="input-group mv-2 wrap pv-1">
      <span>Sex:</span>
      <input type="radio" name="sex" value="male" v-model="sex">
      <span>Male</span>
      <input type="radio" name="sex" value="female" v-model="sex">
      <span>Female</span>
      <input type="radio" name="sex" value="other" v-model="sex">
      <span>Other</span>
    </div>

    <div class="input-group mv-2 wrap pv-1">
      <span class="w-100">Looking for:</span>
      <input type="radio" name="sexualInterest" value="male" v-model="sexualPreference">
      <span>Men</span>
      <input type="radio" name="sexualInterest" value="female" v-model="sexualPreference">
      <span>Women</span>
      <input type="radio" name="sexualInterest" value="both" v-model="sexualPreference">
      <span>Both</span>
      <input type="radio" name="sexualInterest" value="other" v-model="sexualPreference">
      <span>Other</span>
    </div>

    <h4 class="mb-1">Pictures</h4>

    <ImageChooser :images.sync="images" :controls="false"/>

    <p class="text-left">Tell us a little about you hobbies</p>

    <div class="input-group mv-2">
      <input type="text" list="tagList" v-model="tag"
        placeholder="Type in a hobby">
      <datalist id="tagList">
        <option v-for="tag of tagList" :key="tag._id">
          {{ tag.name }}
        </option>
      </datalist>
      <button style="line-height: 50%" class="text-center" @click="addTag">
        <v-icon name="plus"/>
      </button>
    </div>

    <div class="d-flex flex-row flex-wrap mv-5 flex-jc-center">
      <span v-for="tag of userTags" :key="tag" class="tag"
        @click="removeTag(tag)">
        {{ tag }}
      </span>
    </div>

    <AsyncButton :fn="setup" class="w-100 primary mb-2">Setup</AsyncButton>
  </div>
</template>

<script>
import ImageChooser from '@/components/ImageChooser.vue';
import axios from 'axios';

export default {
  data: () => ({
    error: null,
    tag: null,
    tagList: [],

    images: [],
    showImageChooser: false,

    sex: 'other',
    sexualPreference: 'other',
    bio: null,
    userTags: [],
  }),
  components: {
    ImageChooser,
  },
  watch: {
    tag(to) {
      if (!(to && to.trim() !== '')) return ;
      // If the result isn't cached yet complete the tag
      if (!this.tagList.find(el => el.name === to))
        this.completeTag();
    },
  },
  methods: {
    async setup(e) {
      e.preventDefault();

      if (!this.sex || !this.sexualPreference)
        return this.error = 'Sex and sexual preference are required';

      if (this.images.length === 0)
        return this.error = 'You must set at least one profile picture';

      if (this.userTags.length < 3)
        return this.error = 'Minimum of 3 hobbies are required';

      let payload = {
        sex: this.sex,
        sexualPreference: this.sexualPreference,
        interests: this.userTags,
      };

      if (this.bio && this.bio.trim() !== '')
        payload.bio = this.bio;

      try {
        let _images = new Array(this.images.length);

        // Upload all images
        await Promise.all(this.images.map((img, i) => {
          return (async () => {
            let { data } = await axios.post('/api/user/upload_picture', {
              picture: img,
            });
            _images[i] = data.url;
          })();
        }));

        payload.media = _images;

        let { data } = await axios.post('/api/user/setup', payload);

        this.$store.commit('setUser', data);
        this.$router.push('/');
      }
      catch(err) {
        if (err.response) {
          if (err.response.status == 409) {
            this.$store.commit('setUser', err.response.data.user);
            this.$router.push('/');
          }
          else
            this.error = err.response.data.error;
        }
        else
          err;
      }
    },
    completeTag() {
      this.error = null;

      axios.get(`/api/user/complete_tag/${this.tag}`)
        .then(({ data }) => {
          this.tagList = data;
        })
        .catch((err) => {
          // If there is no request it means the request was aborted, ignore
          if (!err.request) return ;
          if (err.response) this.error = err.response.data.error;
        });
    },
    addTag() {
      if (!this.tag || this.tag.trim() === '')
        return ;
      if (this.userTags.indexOf(this.tag) === -1)
        this.userTags.push(this.tag);
      this.tag = null;
    },
    removeTag(tag) {
      let ind = this.userTags.indexOf(tag);
      if (ind !== -1)
        this.userTags.splice(ind, 1);
    },
  },
};
</script>

<style scoped>
.tag {
  padding: .25em 1em;
  margin: .25em;
  color: white;
  background: var(--color-primary);
  border-radius: 1em;

  user-select: none;
  cursor: pointer;

  max-width: 100%;
  overflow: hidden;
  word-wrap: break-word;
}
</style>
